VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TOClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'TOClass Module v2.7
'Warning: use InChatRoomLeave to exit rooms, not toc_chat_leave
'Code is cleared up some, switched to static members, other misc changes.

Private mvarNickname As String     'Server-formatted nick
Private mvarScreenname As String   'Screenname sent to server
Private mvarPassword As String     'Unencrypted Password
Private mvarRemoteHost As String   'Server used
Private mvarRemotePort As Integer  'Server port used
Private mvarSocket As Winsock      'Winsock control used
Private mvarHasSocket As Boolean   'Whether or not a socket is defined
Private mvarIniting As Boolean     'New connection\Respond to CONFIG: toc return with toc_init_done?
Private mvarIsVisible As Boolean   'Can be seen by other users on service?
Private mvarLocalProfile As String 'Profile variable
Private mvarSignedOn As Boolean    'Is there a session running?
Private mvarEvilLevel As Integer   'Stores user warning level.
Private mvarAway As Boolean        'Has user set away flag\message?

'Data for "toc_signon".
Private mvarSignOnPort As Integer
Private mvarSignOnHost As String
Private mvarSignOnLang As String
Private mvarSignOnAgent As String

'Used with changing password.
Private strNewNick$, strNewPass$

'Chat handling.
Public IsMasterClone As Boolean
Public IsCCOMClone As Boolean
Private mvarConsoleClone As Boolean
Private mvarChatName As Collection          'Collection to store chatroom names for rooms user is in.
Private mvarChatID As Collection            'Collection to store chatIDs for rooms user is in.
Private mvarChatExchange As Collection      'Collection to store chatroom exchanges for rooms user is in.
Private mvarHasRoom As Boolean
Private mvarExchangeRendezvous As Integer   'Temporary variable that stores pending exchange entries

'Console window handling.
Private mvarWindowChat As Collection        'Chatroom window storage and handler.
Public IsChecked As Boolean

Public Property Get Away() As Boolean
'Returns whether or not a user is away.

Away = mvarAway
End Property

Public Static Property Get ConsoleChat() As Boolean
'Determines whether a clone is consoled or not.

ConsoleChat = mvarConsoleClone
End Property

Public Static Property Get InChatroomCount() As Integer
'Returns how many aim\aol members are within a chat the user is in.

InChatroomCount = mvarChatName.Count
End Property

Public Static Function InChatRoomSearch(Roomname As String) As Boolean
'Sees whether or not user is in a chatroom

Dim I As Integer
If mvarChatName.Count < 1 Then InChatRoomSearch = False: Exit Function

For I = 1 To mvarChatName.Count
  If Roomname = mvarChatName.Item(I) Then
    InChatRoomSearch = True
    Exit Function
  End If
Next I
InChatRoomSearch = False
End Function

Public Static Function InChatRoomConvIDtoName(ChatID As String) As String
'Converts a chat ID to a chat name.

Dim I As Integer
For I = 1 To mvarChatName.Count
  If ChatID = mvarChatID.Item(I) Then
    InChatRoomConvIDtoName = mvarChatName.Item(I)
    Exit Function
  End If
Next I

InChatRoomConvIDtoName = "(error)"
End Function

Public Static Function InChatRoomConvIDtoExchange(ChatID As String) As Integer
'Converts a chat ID to a chat exchange.

Dim I As Integer
For I = 1 To mvarChatExchange.Count
  If ChatID = mvarChatID.Item(I) Then
    InChatRoomConvIDtoExchange = mvarChatExchange.Item(I)
    Exit Function
  End If
Next I

InChatRoomConvIDtoExchange = 0
End Function

Public Static Function InChatRoomGetName(intidx As Integer) As String
'Return the name of a chatroom from a subscript of the chat collection(s)

If intidx < 1 Then InChatRoomGetName = "(error)": Exit Function
If intidx > mvarChatName.Count Then InChatRoomGetName = "(error)": Exit Function
InChatRoomGetName = mvarChatName(intidx)
End Function

Public Static Function InChatRoomNameToIndex(strRoom As String) As Integer
'A name is given, and an index is returned

Dim I As Integer
For I = 1 To mvarChatName.Count
  If LCase(Replace(mvarChatName.Item(I), " ", "")) = LCase(Replace(strRoom, " ", "")) Then
    InChatRoomNameToIndex = I
    Exit Function
  End If
Next I
End Function

Public Static Sub InChatRoomInvite(intidx As Integer, InviteMsg As String, Buddies As String)
'Invite a user to chatroom from a subscript of the chat collection(s)

If intidx < 1 Then Exit Sub
If intidx > mvarChatName.Count Then Exit Sub
toc_chat_invite mvarChatID(intidx), InviteMsg, Buddies
End Sub

Public Static Function InChatRoomGetID(intidx As Integer) As String
'Return the CHAT ID of a chatroom from a subscript of the chat collection(s)

If intidx < 1 Then InChatRoomGetID = "(error)": Exit Function
If intidx > mvarChatID.Count Then InChatRoomGetID = "(error)": Exit Function
InChatRoomGetID = mvarChatID(intidx)
End Function

Public Static Function InChatRoomGetExchange(intidx As Integer) As Integer
'Return the exchange of a chatroom from a subscript of the chat collection(s)

If intidx < 1 Then InChatRoomGetExchange = 0: Exit Function
If intidx > mvarChatID.Count Then InChatRoomGetExchange = 0: Exit Function
InChatRoomGetExchange = mvarChatExchange(intidx)
End Function

Public Static Sub InChatRoomLeave(intidx As Integer)
'Leaves a chatroom specified by a subscript of the chat collection(s)

If intidx < 1 Then Exit Sub
If intidx > mvarChatName.Count Then Exit Sub

If mvarConsoleClone = True And mvarWindowChat.Count > 0 Then
Dim I As Integer
For I = 1 To mvarWindowChat.Count
  If mvarWindowChat.Item(I).Roomname = mvarChatName.Item(intidx) Then
    ConsoleClose (mvarChatName.Item(intidx))
    Exit For
  End If
Next I
End If

toc_chat_leave mvarChatID.Item(intidx)
mvarChatName.Remove intidx
mvarChatID.Remove intidx
mvarChatExchange.Remove intidx
End Sub

Public Static Sub InChatRoomSend(idx As Integer, Message As String)
'Sends a message to a chatroom specified by a subscript of the chat collection(s)

If idx < 1 Or idx > mvarChatID.Count Then Exit Sub
toc_chat_send mvarChatID.Item(idx), Message
End Sub

Public Static Sub ExitAllChats()
'Exits all rooms the user is in.

If mvarHasRoom = False Then Exit Sub
ConsoleCloseAll
While mvarChatName.Count > 0
  toc_chat_leave mvarChatID.Item(1)
  mvarChatName.Remove 1
  mvarChatID.Remove 1
  mvarChatExchange.Remove 1
Wend
mvarHasRoom = False
End Sub

Public Static Sub SendAllChats(Message As String)
'Sends a message to all chatrooms the user is in.

If mvarHasRoom = False Then Exit Sub
Dim I As Integer
For I = 1 To mvarChatID.Count
  toc_chat_send mvarChatID.Item(I), Message
Next I
End Sub

Public Static Property Get InAChatroom() As Boolean
'Determines whether or not the user is in a chatroom.

If mvarChatID.Count > 0 Then mvarHasRoom = True Else mvarHasRoom = False
InAChatroom = mvarHasRoom
End Property

Public Static Property Get Nickname() As String
'Returns server-formatted nick (Capitalization, spelling).

Nickname = mvarNickname
End Property

Public Static Property Get Screenname() As String
'Returns lcase'd, spaceless sn. (should)

Screenname = mvarScreenname
End Property

Public Static Property Get IsAway() As Boolean
'Has an away message been setup?

IsAway = mvarAway
End Property

Public Static Property Get Password() As String
'Return the user's password.

Password = mvarPassword
End Property

Public Static Property Get WarningLevel() As String
'Return the user's warning level.

WarningLevel = mvarEvilLevel
End Property

Public Static Property Get SignonPort() As String
SignonPort = mvarSignOnPort
End Property

Public Static Property Let SignonPort(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarSignOnPort = strData
End Property

Public Static Property Get SignonHost() As String
SignonHost = mvarSignOnHost
End Property

Public Static Property Let SignonHost(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarSignOnHost = strData
End Property

Public Static Property Get SignonLang() As String
SignonLang = mvarSignOnLang
End Property

Public Static Property Let SignonLang(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarSignOnLang = strData
End Property

Public Static Property Get SignonAgent() As String
SignonAgent = mvarSignOnAgent
End Property

Public Static Property Let SignonAgent(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarSignOnAgent = strData
End Property

Public Static Property Get RemoteHost() As String
RemoteHost = mvarRemoteHost
End Property

Public Static Property Let RemoteHost(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarRemoteHost = strData
End Property

Public Static Property Get RemotePort() As String
RemotePort = mvarRemotePort
End Property

Public Static Property Let RemotePort(ByRef strData As String)
If mvarSignedOn Then Exit Property

mvarRemotePort = strData
End Property

Public Property Set Socket(ByRef vData As Winsock)
Attribute Socket.VB_Description = "Winsock control used by this class."
'Sets the socket used in communications.
'Note: Do not do something stupid, like try and set the socket
'to Nothing, if you do, you deserve to see a program crash.

If mvarSignedOn Then Exit Property

Set mvarSocket = vData
mvarHasSocket = True
End Property

Public Property Get Socket() As Winsock
'Returns a indirect pointer to the socket object being used for
'communications with TOC server.

If mvarHasSocket = False Then
  Err.Raise 10001, "TOC Class", "No windows socket control assiged to TOC Class."
End If
Set Socket = mvarSocket
End Property

Public Static Function HasSocket() As Boolean
If mvarHasSocket Then HasSocket = True Else HasSocket = False
End Function

Public Static Property Get MyProfile() As String
MyProfile = mvarLocalProfile
End Property

Public Static Property Let MyProfile(ByRef strData As String)
mvarLocalProfile = strData
If Not mvarSignedOn Then Exit Property

toc_set_info mvarLocalProfile
End Property

Public Static Property Get IsOnline() As Boolean
'Returns whether or not the user is connected to the TOC server.

IsOnline = mvarSignedOn
End Property

Public Static Property Get AppearOnline() As Boolean
'Returns whether the user is visible to everyone or not.

AppearOnline = mvarIsVisible
End Property

Public Static Property Let AppearOnline(ByRef bData As Boolean)
'Sets whether or not the user appears online.
'Note: if the user stops appearing online when they should,
'try adding a chr(0) to the end of the SendProc commands.
'(null-terminate them)

If bData = mvarIsVisible Then Exit Property

mvarIsVisible = bData
If Not mvarSignedOn Then Exit Property

If mvarIsVisible Then
  SendProc "toc_add_deny " & Chr$(0), 2
Else
  SendProc "toc_add_permit " & Chr$(0), 2
End If
End Property

Public Static Sub Logon(strScreenname As String, strPassword As String)
'Used to logon to the TOC server.

If Not HasSocket Then Exit Sub
If mvarSignedOn Then Logoff
If mvarSocket.state <> sckClosed Then mvarSocket.Close

mvarScreenname = LCase(Replace(strScreenname, " ", ""))
mvarPassword = strPassword
mvarIniting = True

Seqnum True
mvarSocket.Connect mvarRemoteHost, mvarRemotePort
End Sub

Public Static Sub Logoff()
'Disconnect from TOC server.

If mvarHasSocket Then
  If mvarSocket.state = sckConnected Then SendProc vbNullString, 4
  If mvarSocket.state <> sckClosed Then mvarSocket.Close
End If
mvarSignedOn = False
UpdateSNList
End Sub

Private Function Seqnum(Optional Reset As Boolean = False) As Long
'Sequence number used with SFLAP generation.
Static seq As Long

If Reset = True Then
  seq = 1
  Seqnum = seq
  Exit Function
End If

Seqnum = seq
If seq <= 65535 Then
  seq = seq + 1
Else
  seq = 0
End If
End Function

Public Static Sub HandleProc(ByRef strPacket As String)
On Error GoTo hand_problem
If Not HasSocket Then Exit Sub
If Len(strPacket) < 7 Then Exit Sub

Dim FrameType As Byte
Dim ServerSeq As Long
Dim DataLen As Long
Dim ColonPos As Long
Dim PrefixProc As String
Dim ProfixProc As String
Dim DataLenFromColon As Long
Dim datasplit() As String

'Reanalzye gets used if the packet contains more than one SFLAP.
reanalyze:
FrameType = Asc(Mid$(strPacket, 2, 1))
ServerSeq = IntFromLoHiStr(Mid$(strPacket, 3, 2))
DataLen = IntFromLoHiStr(Mid$(strPacket, 5, 2))

strPacket$ = Mid$(strPacket$, 7, Len(strPacket) - 6)
ColonPos = InStr(1, strPacket, ":")
If ColonPos Then
  DataLenFromColon = DataLen - (ColonPos + 1)
  PrefixProc = Mid$(strPacket, 1, ColonPos - 1)
  If ColonPos = Len(strPacket) Then
    ProfixProc = vbNullString
  ElseIf ColonPos >= DataLen Then
    ProfixProc = Mid$(strPacket, 1, DataLen)
  Else
    ProfixProc = Mid$(strPacket, ColonPos + 1, DataLen - (ColonPos))
  End If
End If

flows:

'Splits up parameters sent from server ie:
'<Buddy User>:<Online? T/F>:<Evil Amount>:<Signon Time>:<IdleTime>:<UC>
'<Error Code>:[Var args]
'<Chat Room Id>:<Chat Room Name>
datasplit() = Split(ProfixProc, ":")

Select Case FrameType
  Case 1 'SIGNON
    If Not Len(strPacket) = 4 Then Exit Sub
    If Mid$(strPacket, 1, 4) = Chr(0) & Chr(0) & Chr(0) & Chr(1) Then
      SendProc Chr(0) & Chr(0) & Chr(0) & Chr(1) & Chr(0) & Chr(1) & _
        Chr(0) & Chr(CLng(CStr(Len(Trim(LCase(mvarScreenname)))))) & Trim(LCase(mvarScreenname)), 1
      toc_signon
    End If
  Case 2 'DATA
    Select Case PrefixProc
      Case "SIGN_ON"
        'Outputs TOC version sent from server
        'DebugOut "VERSION", ProfixProc, False
      Case "CONFIG"
        If mvarIniting = True Then
          'Setting capabilities of user
          toc_set_caps
          'This packet needs to get sent, but no parameters need to be passed.
          SendProc "toc_set_config " & Chr(0), 2
          mvarIniting = False
          If Not mvarIsVisible Then
            'Show as offline
            SendProc "toc_add_permit " & Chr(0), 2
            SendProc "toc_init_done" & Chr(0)
            toc_set_info mvarLocalProfile 'Set default info, see cmdSignOn_click
            SendProc "toc_add_deny " & Chr(0), 2
            SendProc "toc_add_permit " & Chr(0), 2
            SendProc "toc_add_permit " & Chr(0), 2
          Else
            'Show as online
            SendProc "toc_add_deny " & Chr(0), 2
            SendProc "toc_init_done" & Chr(0)
            toc_set_info mvarLocalProfile
            SendProc "toc_add_deny " & Chr(0), 2
            SendProc "toc_add_permit " & Chr(0), 2
            SendProc "toc_add_deny " & Chr(0), 2
          End If
          mvarSignedOn = True
          SendProc "toc_get_status " & mvarScreenname & Chr(0), 2
          UpdateSNList
        End If
      Case "NICK"
        'Nickname with spaces and capitalization recieved from server.
        mvarNickname = ProfixProc
      Case "IM_IN"
        'We do not want to split more than 3 items
        'Else if the text the user sent has any ':' in it,
        'We lose the rest of the message. This fixes that.
        datasplit() = Split(ProfixProc, ":", 3)
        
        If Not TOClone.chkMsgbox.Value = Unchecked Then
          If UCase(Trim(datasplit(1))) = "T" Then
            datasplit(2) = datasplit(2) & " [auto-response]"
          End If
          CreateIMWindow datasplit(0), mvarNickname, datasplit(2)
        End If
    
        If Not TOClone.chkAutoWarn.Value = Unchecked Then
          toc_evil datasplit(0), False
        End If
      Case "UPDATE_BUDDY"
        '<Buddy User>:<Online? T/F>:<Evil Amount>:<Signon Time>:<IdleTime>:<UC>
        If LCase(Replace(datasplit(0), " ", "")) = mvarScreenname Then
          mvarEvilLevel = Val(datasplit(2))
          If mvarEvilLevel > 0 Then WrnMsg mvarNickname, "Signed on with a warning level of " & mvarEvilLevel & "%."
        End If
      Case "ERROR"
        If UBound(datasplit) = 0 Then
          ErrMsg mvarScreenname, Val(datasplit(0)), vbNullString
        ElseIf UBound(datasplit) = 1 Then
          ErrMsg mvarScreenname, Val(datasplit(0)), datasplit(1)
        End If
      Case "EVILED"
        If Len(Trim(datasplit(1))) < 1 Then
          WrnMsg mvarScreenname, "Warned anonymously or warning level update from server. New warning level: " & datasplit(0) & "%."
        Else
          WrnMsg mvarScreenname, "Warned by " & datasplit(1) & ". New warning level: " & datasplit(0) & "%."
        End If
        mvarEvilLevel = datasplit(0)
      Case "CHAT_JOIN"
        mvarChatName.Add datasplit(1)
        mvarChatID.Add datasplit(0)
        mvarChatExchange.Add mvarExchangeRendezvous
        mvarHasRoom = True
      Case "CHAT_IN"
        '<Chat Room Id>:<Source User>:<Whisper? T/F>:<Message>
        datasplit() = Split(ProfixProc, ":", 4)
        If mvarConsoleClone Then
          ConsoleIn InChatRoomConvIDtoName(datasplit(0)), datasplit(1), datasplit(3)
        End If
        If IsCCOMClone Then
          Dim temprooms As String
          temprooms = InChatRoomConvIDtoName(datasplit(0))
          CCOMHandler temprooms, InChatRoomConvIDtoExchange(datasplit(0)), InChatRoomNameToIndex(temprooms), mvarScreenname, datasplit(1), datasplit(3)
        End If
      Case "CHAT_UPDATE_BUDDY"
        '<Chat Room Id>:<Inside? T/F>:<User 1>:<User 2>....
        If IsMasterClone And datasplit(1) = "F" Then
          TryAutoEntry datasplit(0), InChatRoomConvIDtoName(datasplit(0)), InChatRoomConvIDtoExchange(datasplit(0)), UBound(datasplit, 1) - 1
        End If
        If mvarConsoleClone Then
          datasplit() = Split(ProfixProc, ":", 3)
          ConsoleBuddies InChatRoomConvIDtoName(datasplit(0)), TextToBool(datasplit(1)), datasplit(2)
        End If
      Case "CHAT_INVITE"
        If Not TOClone.chkAutoWarn.Value = vbUnchecked Then
          toc_evil datasplit(2), False
        End If
      Case "CHAT_LEFT"
        If mvarChatID.Count < 1 Then mvarHasRoom = False
      Case "GOTO_URL"
        'ShellExecute 0, vbNullString, "http://toc.oscar.aol.com/" & datasplit(1), vbNullString, App.Path, SW_SHOWNORMAL
      Case "DIR_STATUS"
        'Ignored packet
      Case "ADMIN_NICK_STATUS"
        'If a good status is returned, the local value is set
        'to whatever is in strNewNick (Should be the new nickname requested)
        mvarNickname = strNewNick
        UpdateUserList strNewNick
      Case "ADMIN_PASSWD_STATUS"
        'If a good status is returned, the local value is set
        'to whatever is in strNewPass (Should be the new password requested)
        WrnMsg mvarNickname, "Password changed from " & mvarPassword & " to " & strNewPass & "."
        mvarPassword = strNewPass
      Case "PAUSE"
        'I have chosen to ignore this. never sent by server anyways.
      Case "RVOUS_PROPOSE"
        'Ignored packet
    End Select
  Case 4 'SIGN_OFF
    Logoff
  Case 3 'ERROR
    Logoff
  Case 5 'KEEP_ALIVE
    'I am not doing anything, nothing is needed to be done.
  Case Else
    'TOCore.DebugOut "ERROR", "Unexpected frametype value: " & FrameType & ".", False
 End Select

If DataLen < Len(strPacket) Then
  'Multiple commands sent on single stream
  strPacket = Mid$(strPacket, DataLen + 1, Len(strPacket) - DataLen)
  GoTo reanalyze
End If
Exit Sub

hand_problem:
TOCore.WrnMsg mvarScreenname, "Program Error: " & Err.Description
Err.Clear
End Sub

Public Static Sub SendProc(ByRef strProcedure As String, Optional ByRef intFrame As Integer = 2)
'Routine used to send messages to server.
'SFLAPs are automaticly attached.

'SFLAP Documentation
'===================
'SFLAP is pretty much a FLAP connection except the DATA frame payload is a null
'terminated string when traveling from client to host, it is NOT null
'terminated when traveling from host to client.  The FLAP Header is binary
'data, and is in network byte order.  The data portion is at offset 6, after the
'header.  The sequence number is sequential in each direction.  So
'packets from the server to client have one sequence number, while
'the packets from the client to server have an independent
'increasing number.

'FLAP Header (6 bytes)
'-----------
'Offset   Size  Type
'0        1     ASTERISK (literal ASCII '*')
'1        1     Frame Type
'2        2     Sequence Number
'4        2     Data Length

'Valid Frame Type Values
'-----------------------
'1   SIGNON
'2   DATA
'3   ERROR     (Not used by TOC)
'4   SIGNOFF   (Not used by TOC)
'5   KEEP_ALIVE

On Error GoTo errsp
If Not HasSocket Then Exit Sub

Dim intseq As Long: intseq = Seqnum
Dim DataLen As Long: DataLen = Len(strProcedure$)

Dim SeqHi As Byte, SeqLo As Byte
Dim LenHi As Byte, LenLo As Byte

SeqHi = Hi(intseq)
SeqLo = Lo(intseq)
LenHi = Hi(DataLen)
LenLo = Lo(DataLen)

'TOCore.DebugOut "OUT", _
'  "*" & _
'  Chr(intFrame) & _
'  Chr(SeqLo) & _
'  Chr(SeqHi) & _
'  Chr(LenLo) & _
'  Chr(LenHi) & _
'  strProcedure$, True

If mvarSocket.state <> sckConnected Then
  Logoff
Else
  mvarSocket.SendData _
    "*" & _
    Chr(intFrame) & _
    Chr(SeqLo) & _
    Chr(SeqHi) & _
    Chr(LenLo) & _
    Chr(LenHi) & _
    strProcedure$
  Exit Sub
End If

errsp:
Logoff
End Sub

Private Static Sub toc_signon()
'The password needs to be roasted with the Roasting String if
'coming over a FLAP connection, CP connections don't use
'roasted passwords.  The language specified will be used
'when generating web pages, such as the get info pages.
'Currently the only supported language is "english".
'If the language sent isn't found, the default "english"
'language will be used.  The version string will be used
'for the client identity, and must be less then 50
'characters.
'Passwords are roasted when sent to the host.  This is done so they
'aren't sent in "clear text" over the wire, although they are still
'trivial to decode.  Roasting is performed by first xoring each byte
'in the password with the equivalent modulo byte in the roasting
'string.  The result is then converted to ascii hex, and prepended
'with "0x".  So for example the password "password" roasts to
'"0x2408105c23001130"
    
SendProc "toc_signon " & mvarSignOnHost & " " & mvarSignOnPort & "  " & Trim(LCase(mvarScreenname)) & " " & EncryptPW(mvarPassword) & " " & mvarSignOnLang & " " & Chr(34) & SlashFormat(mvarSignOnAgent) & Chr(34) & Chr(0)
End Sub

Public Static Sub toc_send_im(User As String, Message As String, Optional AutoReplyFlag As Boolean = False)
'Send a message to a remote user.  Remember to quote and encode the
'message.  If the optional string "auto" is the last argument, then the
'auto response flag will be turned on for the im.
    
Dim strMsg As String
strMsg = LCase(Replace(User, " ", "")) & " " & Chr$(34) & SlashFormat(Message) & Chr$(34)
If AutoReplyFlag Then strMsg = strMsg & " auto"
SendProc "toc_send_im " & strMsg & Chr(0)
End Sub

Public Static Sub toc_chat_join(Exchange As Integer, ChatName As String)
'Join a chat room in the given exchange.  Exchange is
'an integer that represents a group of chat rooms.
'Different exchanges have different properties.  For
'example some exchanges might have room replication (ie
'a room never fills up, there are just multiple
'instances.) and some exchanges might have navigational
'information, and some exchanges might have ...
'You will either receive an ERROR if the room couldn't be joined
'or a CHAT_JOIN message.  The Chat Room Name
'is case insensitive and consecutive spaces
'are removed. The ChatRoomID is givin when a CHAT_JOIN
'command is sent from the server. ChatRoomID and ChatName
'are not the same thing!
    
mvarExchangeRendezvous = Exchange
SendProc "toc_chat_join " & Exchange & " " & ChatName & Chr(0)
End Sub

Private Static Sub toc_chat_send(ChatRoomID As String, Message As String)
'Send a message in a chat room using the chat room
'id from CHAT_JOIN.  Since reflection is always on in
'TOC, you do not need to add the message to your chat UI,
'since you will get a CHAT_IN with the message.
'Remember to quote and encode the message.

If ChatRoomID = "(error)" Then Exit Sub
SendProc "toc_chat_send " & ChatRoomID & " " & Chr$(34) & SlashFormat(Message) & Chr$(34) & Chr(0)
End Sub

Public Static Sub toc_chat_whisper(ChatRoomID As String, dst_user As String, Message As String)
'Send a message in a chat room using the chat room
'id from CHAT_JOIN.  This message is directed at
'only one person.  (Currently you DO need to add this to
'your UI.)  Remember to quote and encode the message.
'Chat whispering is different from IMs since it is linked
'to a chat room, and should usually be displayed in the chat
'room UI. (This isn't handled by the chat server currently)

SendProc "toc_chat_whisper " & ChatRoomID & " " & LCase(Replace(dst_user, " ", "")) & " " & Chr$(34) & SlashFormat(Message) & Chr$(34) & Chr(0)
End Sub

Public Static Sub toc_chat_evil(ChatRoomID As String, User As String, Optional Anonymous As Boolean = True)
'Evil/Warn someone else inside a chat room.  The 3rd argument is either
'the string "norm" for a normal warning, or "anon" for an anonymous
'warning.  Currently chat evil is not turned on in the chat complex.

Dim strMsg As String
strMsg = ChatRoomID & " " & LCase(Replace(User, " ", "")) & " "
If Anonymous Then
  strMsg = strMsg & "anon"
Else
  strMsg = strMsg & "norm"
End If
SendProc "toc_chat_evil " & strMsg & Chr(0)
End Sub

Public Static Sub toc_chat_invite(ChatRoomID As String, InviteMsg As String, Buddies As String)
'Once you are inside a chat room you can invite other people into
'that room.  Remember to quote and encode the invite message.

SendProc "toc_chat_invite " & ChatRoomID & " " & Chr$(34) & SlashFormat(InviteMsg) & Chr$(34) & " " & Buddies & Chr(0)
End Sub

Public Static Sub toc_chat_leave(ChatRoomID As String)
'Leave the chat room.
    
SendProc "toc_chat_leave " & ChatRoomID & Chr(0)
End Sub

Public Static Sub toc_chat_accept(ChatRoomID As String)
'Accept a CHAT_INVITE message from TOC.  The server will send a
'CHAT_JOIN in response.
    
SendProc "toc_chat_accept " & ChatRoomID & Chr(0)
End Sub

Public Static Sub toc_evil(User As String, Optional Anonymous As Boolean = True)
'Evil/Warn someone else.  The 2nd argument is either the string
'"norm" for a normal warning, or "anon" for an anonymous
'warning.  You can only evil people who have recently sent you
'ims.  The higher someones evil level, the slower they can
'send message.
    
Dim strMsg As String
strMsg = LCase(Replace(User, " ", "")) & " "
If Anonymous Then
  strMsg = strMsg & "anon"
Else
  strMsg = strMsg & "norm"
End If
SendProc "toc_evil " & strMsg & Chr(0)
End Sub

Public Static Sub toc_set_caps(Optional strCaps As String = "748F2420-6287-11D1-8222-444553540000,1348,134B,1341,1343,1FF,1345,1346,1347,")
'Set my capabilities.  All capabilities that we support need to
'be sent at the same time.  Capabilities are represented by UUIDs.
    
SendProc "toc_set_caps " & strCaps & Chr(0)
End Sub

Public Static Sub toc_set_info(strInfo As String)
'Set the LOCATE user information.  This is basic HTML.
'Remember to encode the info with the slashformat routine.

SendProc "toc_set_info " & Chr$(34) & SlashFormat(strInfo) & Chr$(34) & Chr(0)
End Sub

Public Static Sub toc_get_info(username As String)
'Gets a user's info a GOTO_URL or ERROR message will be sent back to the
'client.

SendProc "toc_get_info " & Chr$(34) & SlashFormat(username) & Chr$(34) & Chr(0)
End Sub

Public Static Sub toc_set_away(awaymessage As String)
'if the away message is present, then the unavailable
'status flag is set for the user.  If the away message
'is not present, then the unavailable status flag is
'unset.  The away message is basic HTML, remember to
'encode the information with the slashformat routine.
    
If Len(awaymessage) > 1 Then mvarAway = True Else mvarAway = False
SendProc "toc_set_away " & Chr$(34) & SlashFormat(awaymessage) & Chr$(34) & Chr(0)
End Sub

Public Static Sub toc_get_dir(username As String)
'Gets a user's dir info a GOTO_URL or ERROR message will be
'sent back to the client.

SendProc "toc_get_dir " & LCase(Replace(username, " ", "")) & Chr(0)
End Sub

Public Static Sub toc_set_idle(idlesecs As Long)
'Set idle information. If <idle secs> is 0 then the user isn't idle at all.
'If <idle secs> is greater then 0 then the user has already been idle
'for <idle secs> number of seconds.  The server will automatically
'keep incrementing this number, so do not repeatedly call with new
'idle times.

SendProc "toc_set_idle " & idlesecs & Chr(0)
End Sub

Public Static Sub toc_format_nickname(new_format As String)
'Reformat a user's nickname.  An ADMIN_NICK_STATUS or ERROR message will
'be sent back to the client.

strNewNick$ = new_format
SendProc "toc_format_nickname " & Chr(34) & SlashFormat(new_format) & Chr(34) & Chr(0)
End Sub

Public Static Sub toc_change_passwd(existing_passwd As String, new_passwd As String)
'Change a user's password.  An ADMIN_PASSWD_STATUS or ERROR message will
'be sent back to the client.

strNewPass$ = new_passwd
SendProc "toc_change_passwd " & Chr(34) & SlashFormat(existing_passwd) & Chr(34) & " " & Chr(34) & SlashFormat(new_passwd) & Chr(34) & Chr(0)
End Sub

Public Static Sub toc_set_dir(firstname As String, middlename As String, lastname As String, maidenname As String, city As String, state As String, country As String, email As String, Optional allowwebsearch As Boolean = True)
'Set the DIR user information.  This is a colon separated fields as in:
'"first name":"middle name":"last name":"maiden name":"city":"state":"country":"email":"allow web searches"
'Should return a DIR_STATUS msg.  Having anything in the "allow web searches"
'field allows people to use web-searches to find your directory info.
'Otherwise , they'd have to use the client.

Dim websearch As String
If allowwebsearch Then
  websearch = "allow"
Else
  websearch = vbNullString
End If

SendProc "toc_set_dir " & firstname & ":" & middlename & ":" & lastname & ":" & maidenname & ":" & city & ":" & state & ":" & country & ":" & email & ":" & websearch & Chr(0)
End Sub

Public Static Sub toc_dir_search(firstname As String, middlename As String, lastname As String, maidenname As String, city As String, state As String, country As String, email As String)
'Perform a search of the Oscar Directory, using colon separated fields as in:
'"first name":"middle name":"last name":"maiden name":"city":"state":"country":"email"
'Returns either a GOTO_URL or ERROR msg.

SendProc "toc_dir_search " & firstname & ":" & middlename & ":" & lastname & ":" & maidenname & ":" & city & ":" & state & ":" & country & ":" & email & Chr(0)
End Sub

Private Sub Class_Initialize()
Set mvarChatName = New Collection     'Collection to store chatroom names for rooms user is in.
Set mvarChatID = New Collection       'Collection to store chatIDs for rooms user is in.
Set mvarChatExchange = New Collection 'Collection to store chatroom exchanges for rooms user is in.
Set mvarWindowChat = New Collection   'Collection to store chatroom windows for rooms user is in.
End Sub

Private Static Sub Class_Terminate()
'Destructor called when class goes out of scope or removed from memory.

Logoff  'Calls member routine that disconnects from server.
Set mvarChatName = Nothing    'Set pointer to null.
Set mvarChatID = Nothing      'Set pointer to null.
Set mvarSocket = Nothing      'Set pointer to null.

ConsoleCloseAll
Set mvarWindowChat = Nothing  'Ditto.
End Sub

Private Sub ConsoleBuddies(Chatroom As String, Inside As Boolean, SNList As String)
'update buddys list
Dim I As Integer
For I = 1 To mvarWindowChat.Count
  If mvarWindowChat.Item(I).Roomname = Chatroom Then
    mvarWindowChat.Item(I).ChatUser Inside, SNList
  End If
Next I
End Sub

Public Sub ConsoleOpen(Chatroom As String, Exchange As Integer)
'add it to a list
'open up a window

Dim I As Integer
Dim g As Integer
Dim timeoutsector As Single
Dim timeoutnum As Integer

g = mvarChatName.Count
For I = 1 To g
  If mvarChatName.Item(I) = Chatroom Then
    timeoutnum = mvarChatName.Count
    InChatRoomLeave I
    timeoutsector = Timer + 1
    While Timer < timeoutsector Or timeoutnum = mvarChatName.Count
      DoEvents
    Wend
    mvarWindowChat.Add New TOChatConsole
    mvarWindowChat.Item(mvarWindowChat.Count).Screenname = mvarScreenname
    mvarWindowChat.Item(mvarWindowChat.Count).Exchange = Exchange
    mvarWindowChat.Item(mvarWindowChat.Count).Roomname = Chatroom
    mvarWindowChat.Item(mvarWindowChat.Count).Show
    mvarConsoleClone = True
    toc_chat_join Exchange, Chatroom
    Exit Sub
  End If
Next I
End Sub

Public Sub ConsoleClose(Chatroom As String)
'remove it from the list
Dim I As Integer
For I = 1 To mvarWindowChat.Count
  If mvarWindowChat.Item(I).Roomname = Chatroom Then
    mvarWindowChat.Remove I
  End If
Next I
If mvarWindowChat.Count = 0 Then mvarConsoleClone = False
End Sub

Public Function ConsoleExists(Chatroom As String) As Boolean
'see if it already exists
Dim I As Integer
For I = 1 To mvarWindowChat.Count
  If mvarWindowChat.Item(I).Roomname = Chatroom Then
    ConsoleExists = True
    Exit Function
  End If
Next I
ConsoleExists = False
End Function

Public Sub ConsoleCloseAll()
While mvarWindowChat.Count > 0
  mvarWindowChat(1).Visible = False
  mvarWindowChat.Remove 1
Wend
mvarConsoleClone = False
End Sub

Private Sub ConsoleIn(Chatroom As String, User As String, Text As String)
'incoming chat
Dim I As Integer
For I = 1 To mvarWindowChat.Count
  If mvarWindowChat.Item(I).Roomname = Chatroom Then
    mvarWindowChat.Item(I).ChatString User, Text
  End If
Next I
End Sub
